export const DATA_CONFIG = {
  gridConfig: [
    { label: '景区名称',
      prop: 'scenicCodeDisplay'
    },
  ],
  queryConfig: [
    { span: 24,
      label:'景区名称',
      prop: 'scenicCode',
      type: 'select',
      dataScource:'fe2e15c3a4f175bcf860aba5e2f09bbd',
      data:[]
    },
  ],
  // crud的模态框表单配置，可配置表单类型，验证规则，是否必填,col-span布局可通过span参数配置
  formConfig: [
      {
          groupName:'客流量信息配置(单位:人)',
          data:[
              { span: 12,
                label:'景区名称',
                prop: 'scenicCodeDisplay',
                type: 'label'
              }, 
              { span: 12,
                label:'今日承载量',
                prop: 'scenicNumber',
                type: 'integer',
                min:0,
                rules:[
                  {
                    required: true,
                    message: '请输入今日承载量',
                    trigger: 'blur'
                  },
                ],
                data:[]
              }
          ]
      },{
          groupName:'舒适参数配置(单位:百分比)',
          data:[
                { span: 12,
                  label:'舒适最小值',
                  prop: 'comfortableMin',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                },
                { span: 12,
                  label:'舒适最大值',
                  prop: 'comfortableMax',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                },
                { span: 12,
                  label:'适中最小值',
                  prop: 'moderateMin',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                },
                { span: 12,
                  label:'适中最大值',
                  prop: 'moderateMax',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                },
                { span: 12,
                  label:'拥挤最小值',
                  prop: 'crowdingMin',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                },
                { span: 12,
                  label:'拥挤最大值',
                  prop: 'crowdingMax',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                },
                { span: 12,
                  label:'预警最小值',
                  prop: 'alarmMin',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                },
                { span: 12,
                  label:'预警最大值',
                  prop: 'alarmMax',
                  type: 'integer',
                  min:0,
                  max:100,
                  rules:[
                	  ],
                  data:[]
                }
          ]
      },
      {
          groupName:'预警范围配置(单位:小时)',
          data:[
              { span: 12,
                label:'级别一最小值',
                prop: 'oneMin',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              { span: 12,
                label:'级别一最大值',
                prop: 'oneMax',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              { span: 12,
                label:'级别二最小值',
                prop: 'twoMin',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              { span: 12,
                label:'级别二最大值',
                prop: 'twoMax',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              { span: 12,
                label:'级别三最小值',
                prop: 'threeMin',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              { span: 12,
                label:'级别三最大值',
                prop: 'threeMax',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              { span: 12,
                label:'级别四最小值',
                prop: 'fourMin',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              { span: 12,
                label:'级别四最大值',
                prop: 'fourMax',
                type: 'integer',
                rules:[
              	  ],
                data:[]
              },
              
          ]
      },
      {
          groupName:'负责人配置',
          data:[
              { span: 24,
                label:'负责人',
                prop: 'userName',
                type: 'openSelect',
                max: 40,
                rules:[
                    {
                      required: true,
                      message: '请选择负责人',
                      trigger: 'blur'
                    }
              	  ],
                data:[]
              }
          ]
      }
  ],

  // crud的操作按钮配置，基础按钮有添加、修改、删除、查看，还可以配置扩展按钮
  gridTopBtnConfig: [
  ],

dialogConfig:{
  labelWidth:'120px',
  isGroup:true
},
 gridOperaBtnConfig:[

 ],
 gridBtnConfig: [

 ],
  // 表单基础数据类型，需要预先赋值
  formModel: {
    'id' : '',
    'scenicCode': '',
    'scenicNumber': '',
    'comfortableMin': '',
    'comfortableMax': '',
    'moderateMin': '',
    'moderateMax': '',
    'crowdingMin': '',
    'crowdingMax': '',
    'alarmMin': '',
    'alarmMax': '',
    'alarmStandard': '',
    'userId': '',
    'userName':''
  },
  queryModel: {
    'scenicCode' : null,
  }
}
